<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.18"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>XHXKit: XHXKit/Classes/Navigator/XHXNavigator.m 源文件</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">XHXKit
   &#160;<span id="projectnumber">4.10.0.12</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- 制作者 Doxygen 1.8.18 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'搜索');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','搜索');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(document).ready(function(){initNavTree('_x_h_x_navigator_8m_source.html',''); initResizable(); });
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">XHXNavigator.m</div>  </div>
</div><!--header-->
<div class="contents">
<a href="_x_h_x_navigator_8m.html">浏览该文件的文档.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno"><a class="line" href="interface_x_h_x_navigator.html#ae092b2e06c16c8dc6f01988ad1886a50">    1</a></span>&#160;<span class="comment">//</span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment">//  XHXNavigator.m</span></div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment">//  KKLOnLine</span></div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment">//</span></div>
<div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment">//  Created by Leovir on 2018/5/18.</span></div>
<div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="comment">//  Copyright © 2018年 mistong. All rights reserved.</span></div>
<div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="comment">//</span></div>
<div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160; </div>
<div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="preprocessor">#import &quot;<a class="code" href="_x_h_x_navigator_8h.html">XHXNavigator.h</a>&quot;</span></div>
<div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160; </div>
<div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="keyword">@implementation </span><a class="code" href="interface_x_h_x_navigator.html">XHXNavigator</a></div>
<div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="preprocessor">#pragma mark ==================  返回根视图 根Window 顶层window   ==================</span></div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="comment">//获取rootviewcontroller</span></div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;+ (UIViewController *)<a class="code" href="interface_x_h_x_navigator.html#a1ab38ab3ebac8021bf5ebad00d76d203">rootViewController</a></div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;{</div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;    <span class="keywordflow">return</span> [UIApplication sharedApplication].delegate.window.rootViewController;</div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;}</div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="comment">//获取appdelegate的window</span></div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;+ (UIWindow *)<a class="code" href="interface_x_h_x_navigator.html#ac4ee4d0dd9d4258a7388d48bd416c528">rootWindow</a></div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;{</div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;    <span class="keywordflow">return</span> [UIApplication sharedApplication].delegate.window;</div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;}</div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;<span class="comment">//最顶层的window</span></div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;+ (UIWindow *)<a class="code" href="interface_x_h_x_navigator.html#ae092b2e06c16c8dc6f01988ad1886a50">topWindow</a></div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;{</div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;    <span class="keywordflow">return</span> [UIApplication sharedApplication].windows.lastObject;</div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;}</div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;<span class="comment">//keywindow</span></div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;+ (UIWindow *)<a class="code" href="interface_x_h_x_navigator.html#acc91401082b35660f529465910e26577">keyWindow</a></div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;{</div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;    <span class="keywordflow">return</span> [UIApplication sharedApplication].keyWindow;</div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;}</div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;<span class="preprocessor">#pragma mark ==================  public method  ==================</span></div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;+ (UIViewController *)<a class="code" href="interface_x_h_x_navigator.html#a2386702d61e0ba8a8c3ded4c36aee1fc">currentViewController</a> {</div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;    <span class="keywordflow">return</span> [<span class="keyword">self</span> currentViewControllerFrom:self.rootViewController];</div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;}</div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160; </div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;+ (UINavigationController *)<a class="code" href="interface_x_h_x_navigator.html#a5cf12ce028b8a0156c3cfd997f7c32b1">currentNavigationController</a></div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;{</div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;    UIViewController *<a class="code" href="interface_x_h_x_navigator.html#a2386702d61e0ba8a8c3ded4c36aee1fc">currentViewController</a> = <span class="keyword">self</span>.currentViewController;</div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;    <span class="keywordflow">return</span> <a class="code" href="interface_x_h_x_navigator.html#a2386702d61e0ba8a8c3ded4c36aee1fc">currentViewController</a>.navigationController;</div>
<div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;}</div>
<div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;<span class="preprocessor">#pragma mark ==================  push   ==================</span></div>
<div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;+ (void)pushViewController:(UIViewController *)viewController animated:(BOOL)animated</div>
<div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;{</div>
<div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;    <span class="comment">//  不存在直接返回</span></div>
<div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;    <span class="keywordflow">if</span> (!viewController) <span class="keywordflow">return</span>;</div>
<div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;    <span class="keywordflow">if</span> ([viewController isKindOfClass:[UINavigationController <span class="keyword">class</span>]]) {</div>
<div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;    } <span class="keywordflow">else</span> {</div>
<div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;        UINavigationController *navigationController = [<a class="code" href="interface_x_h_x_navigator.html">XHXNavigator</a> <a class="code" href="interface_x_h_x_navigator.html#a5cf12ce028b8a0156c3cfd997f7c32b1">currentNavigationController</a>];</div>
<div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;        <span class="comment">//  如果不存在导航控制器 直接返回</span></div>
<div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;        <span class="keywordflow">if</span> (!navigationController) <span class="keywordflow">return</span>;</div>
<div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;        [navigationController pushViewController:viewController animated:animated];</div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;    }</div>
<div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;}</div>
<div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;<span class="preprocessor">#pragma mark ==================  present   ==================</span></div>
<div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;+ (void)presentViewController:(UIViewController *)viewController animated:(BOOL)animated</div>
<div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;{</div>
<div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;    <span class="keywordflow">return</span> [<span class="keyword">self</span> presentViewController:viewController animated:animated completion:nil];</div>
<div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;}</div>
<div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;+ (void)presentViewController:(UIViewController *)viewController animated:(BOOL)animated completion:(<span class="keywordtype">void</span> (^)(<span class="keywordtype">void</span>))completion</div>
<div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;{</div>
<div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;    <span class="comment">//  不存在直接返回</span></div>
<div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;    <span class="keywordflow">if</span> (!viewController) <span class="keywordflow">return</span>;</div>
<div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;    UIViewController *<a class="code" href="interface_x_h_x_navigator.html#a2386702d61e0ba8a8c3ded4c36aee1fc">currentViewController</a> = [<a class="code" href="interface_x_h_x_navigator.html">XHXNavigator</a> <a class="code" href="interface_x_h_x_navigator.html#a2386702d61e0ba8a8c3ded4c36aee1fc">currentViewController</a>];</div>
<div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;    <span class="keywordflow">if</span> (!<a class="code" href="interface_x_h_x_navigator.html#a2386702d61e0ba8a8c3ded4c36aee1fc">currentViewController</a>) <span class="keywordflow">return</span>;</div>
<div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;    [currentViewController presentViewController:viewController animated:animated completion:completion];</div>
<div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;}</div>
<div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;<span class="preprocessor">#pragma mark ==================  pop   ==================</span></div>
<div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;+ (void)popViewControllerWithTimes:(NSUInteger)times animated:(BOOL)animated</div>
<div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;{</div>
<div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;    UIViewController *<a class="code" href="interface_x_h_x_navigator.html#a2386702d61e0ba8a8c3ded4c36aee1fc">currentViewController</a> = [<a class="code" href="interface_x_h_x_navigator.html">XHXNavigator</a> <a class="code" href="interface_x_h_x_navigator.html#a2386702d61e0ba8a8c3ded4c36aee1fc">currentViewController</a>];</div>
<div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;    UINavigationController *<a class="code" href="interface_x_h_x_navigator.html#a5cf12ce028b8a0156c3cfd997f7c32b1">currentNavigationController</a> = <a class="code" href="interface_x_h_x_navigator.html#a2386702d61e0ba8a8c3ded4c36aee1fc">currentViewController</a>.navigationController;</div>
<div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;    <span class="comment">//  两者缺一不可</span></div>
<div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;    <span class="keywordflow">if</span> (!<a class="code" href="interface_x_h_x_navigator.html#a2386702d61e0ba8a8c3ded4c36aee1fc">currentViewController</a> || !<a class="code" href="interface_x_h_x_navigator.html#a5cf12ce028b8a0156c3cfd997f7c32b1">currentNavigationController</a>) <span class="keywordflow">return</span>;</div>
<div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;    NSUInteger count = <a class="code" href="interface_x_h_x_navigator.html#a5cf12ce028b8a0156c3cfd997f7c32b1">currentNavigationController</a>.viewControllers.count;</div>
<div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;    <span class="keywordflow">if</span> (count &gt; times) {</div>
<div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;        [currentNavigationController popToViewController:[currentNavigationController.viewControllers objectAtIndex:count - 1 - times] animated:animated];</div>
<div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;    }</div>
<div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;}</div>
<div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;+ (void)popToRootViewControllerAnimated:(BOOL)animated</div>
<div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;{</div>
<div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;    UINavigationController *<a class="code" href="interface_x_h_x_navigator.html#a5cf12ce028b8a0156c3cfd997f7c32b1">currentNavigationController</a> = [<a class="code" href="interface_x_h_x_navigator.html">XHXNavigator</a> <a class="code" href="interface_x_h_x_navigator.html#a5cf12ce028b8a0156c3cfd997f7c32b1">currentNavigationController</a>];</div>
<div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;    <span class="comment">//  不存在导航控制器 直接返回</span></div>
<div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;    <span class="keywordflow">if</span> (!<a class="code" href="interface_x_h_x_navigator.html#a5cf12ce028b8a0156c3cfd997f7c32b1">currentNavigationController</a>) <span class="keywordflow">return</span>;</div>
<div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;    NSUInteger count = <a class="code" href="interface_x_h_x_navigator.html#a5cf12ce028b8a0156c3cfd997f7c32b1">currentNavigationController</a>.viewControllers.count;</div>
<div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;    [<span class="keyword">self</span> popViewControllerWithTimes:count - 1 animated:animated];</div>
<div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;}</div>
<div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;<span class="preprocessor">#pragma mark ==================  dismiss   ==================</span></div>
<div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;+ (void)dismissViewControllerTimes:(NSUInteger)times animated:(BOOL)animated completion:(<span class="keywordtype">void</span> (^)(<span class="keywordtype">void</span>))completion</div>
<div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;{</div>
<div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;    UIViewController *<a class="code" href="interface_x_h_x_navigator.html#a2386702d61e0ba8a8c3ded4c36aee1fc">currentViewController</a> = [<a class="code" href="interface_x_h_x_navigator.html">XHXNavigator</a> <a class="code" href="interface_x_h_x_navigator.html#a2386702d61e0ba8a8c3ded4c36aee1fc">currentViewController</a>];</div>
<div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;    <span class="comment">//  两者缺一不可</span></div>
<div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;    <span class="keywordflow">if</span> (!<a class="code" href="interface_x_h_x_navigator.html#a2386702d61e0ba8a8c3ded4c36aee1fc">currentViewController</a> || !<a class="code" href="interface_x_h_x_navigator.html#a2386702d61e0ba8a8c3ded4c36aee1fc">currentViewController</a>.presentingViewController) <span class="keywordflow">return</span>;</div>
<div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;    <span class="keywordflow">while</span> (times &gt; 0) {</div>
<div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;        <a class="code" href="interface_x_h_x_navigator.html#a2386702d61e0ba8a8c3ded4c36aee1fc">currentViewController</a> = <a class="code" href="interface_x_h_x_navigator.html#a2386702d61e0ba8a8c3ded4c36aee1fc">currentViewController</a>.presentingViewController;</div>
<div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;        <span class="keywordflow">if</span> (!<a class="code" href="interface_x_h_x_navigator.html#a2386702d61e0ba8a8c3ded4c36aee1fc">currentViewController</a>.presentingViewController) <span class="keywordflow">break</span>;</div>
<div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;        times -= 1;</div>
<div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;    }</div>
<div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;    [currentViewController dismissViewControllerAnimated:animated completion:completion];</div>
<div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;}</div>
<div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;+ (void)dismissToRootViewControllerAnimated:(BOOL)animated completion:(<span class="keywordtype">void</span> (^)(<span class="keywordtype">void</span>))completion</div>
<div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;{</div>
<div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;    UIViewController *<a class="code" href="interface_x_h_x_navigator.html#a2386702d61e0ba8a8c3ded4c36aee1fc">currentViewController</a> = [<a class="code" href="interface_x_h_x_navigator.html">XHXNavigator</a> <a class="code" href="interface_x_h_x_navigator.html#a2386702d61e0ba8a8c3ded4c36aee1fc">currentViewController</a>];</div>
<div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;    <span class="comment">//  两者缺一不可</span></div>
<div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;    <span class="keywordflow">if</span> (!<a class="code" href="interface_x_h_x_navigator.html#a2386702d61e0ba8a8c3ded4c36aee1fc">currentViewController</a> || !<a class="code" href="interface_x_h_x_navigator.html#a2386702d61e0ba8a8c3ded4c36aee1fc">currentViewController</a>.presentingViewController) <span class="keywordflow">return</span>;</div>
<div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;    <span class="keywordflow">while</span> (<a class="code" href="interface_x_h_x_navigator.html#a2386702d61e0ba8a8c3ded4c36aee1fc">currentViewController</a>.presentingViewController) {</div>
<div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160;        <a class="code" href="interface_x_h_x_navigator.html#a2386702d61e0ba8a8c3ded4c36aee1fc">currentViewController</a> = <a class="code" href="interface_x_h_x_navigator.html#a2386702d61e0ba8a8c3ded4c36aee1fc">currentViewController</a>.presentingViewController;</div>
<div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;    }</div>
<div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;    [currentViewController dismissViewControllerAnimated:animated completion:completion];</div>
<div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;}</div>
<div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;<span class="preprocessor">#pragma mark ==================  private method  ==================</span></div>
<div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;<span class="comment">// 通过递归拿到当前控制器</span></div>
<div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160;+ (UIViewController*)currentViewControllerFrom:(UIViewController*)viewController {</div>
<div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160;    <span class="keywordflow">if</span> ([viewController isKindOfClass:[UINavigationController <span class="keyword">class</span>]]) {</div>
<div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;        UINavigationController* navigationController = (UINavigationController *)viewController;</div>
<div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;        <span class="keywordflow">return</span> [<span class="keyword">self</span> currentViewControllerFrom:navigationController.viewControllers.lastObject];</div>
<div class="line"><a name="l00118"></a><span class="lineno">  118</span>&#160;    } <span class="comment">// 如果传入的控制器是导航控制器,则返回最后一个</span></div>
<div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160;    <span class="keywordflow">else</span> <span class="keywordflow">if</span>([viewController isKindOfClass:[UITabBarController <span class="keyword">class</span>]]) {</div>
<div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160;        UITabBarController* tabBarController = (UITabBarController *)viewController;</div>
<div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;        <span class="keywordflow">return</span> [<span class="keyword">self</span> currentViewControllerFrom:tabBarController.selectedViewController];</div>
<div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;    } <span class="comment">// 如果传入的控制器是tabBar控制器,则返回选中的那个</span></div>
<div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;    <span class="keywordflow">else</span> <span class="keywordflow">if</span>(viewController.presentedViewController != nil) {</div>
<div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;        <span class="keywordflow">return</span> [<span class="keyword">self</span> currentViewControllerFrom:viewController.presentedViewController];</div>
<div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;    } <span class="comment">// 如果传入的控制器发生了modal,则就可以拿到modal的那个控制器</span></div>
<div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160;    <span class="keywordflow">else</span> {</div>
<div class="line"><a name="l00127"></a><span class="lineno">  127</span>&#160;        <span class="keywordflow">return</span> viewController;</div>
<div class="line"><a name="l00128"></a><span class="lineno">  128</span>&#160;    }</div>
<div class="line"><a name="l00129"></a><span class="lineno">  129</span>&#160;}</div>
<div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160;<span class="keyword">@end</span></div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<div class="ttc" id="ainterface_x_h_x_navigator_html"><div class="ttname"><a href="interface_x_h_x_navigator.html">XHXNavigator</a></div><div class="ttdef"><b>Definition:</b> <a href="_x_h_x_navigator_8h_source.html#l00012">XHXNavigator.h:13</a></div></div>
<div class="ttc" id="ainterface_x_h_x_navigator_html_acc91401082b35660f529465910e26577"><div class="ttname"><a href="interface_x_h_x_navigator.html#acc91401082b35660f529465910e26577">+[XHXNavigator keyWindow]</a></div><div class="ttdeci">UIWindow * keyWindow()</div><div class="ttdef"><b>Definition:</b> <a href="_x_h_x_navigator_8m_source.html#l00001">XHXNavigator.m:29</a></div></div>
<div class="ttc" id="a_x_h_x_navigator_8h_html"><div class="ttname"><a href="_x_h_x_navigator_8h.html">XHXNavigator.h</a></div></div>
<div class="ttc" id="ainterface_x_h_x_navigator_html_a5cf12ce028b8a0156c3cfd997f7c32b1"><div class="ttname"><a href="interface_x_h_x_navigator.html#a5cf12ce028b8a0156c3cfd997f7c32b1">+[XHXNavigator currentNavigationController]</a></div><div class="ttdeci">UINavigationController * currentNavigationController()</div><div class="ttdef"><b>Definition:</b> <a href="_x_h_x_navigator_8m_source.html#l00001">XHXNavigator.m:38</a></div></div>
<div class="ttc" id="ainterface_x_h_x_navigator_html_a2386702d61e0ba8a8c3ded4c36aee1fc"><div class="ttname"><a href="interface_x_h_x_navigator.html#a2386702d61e0ba8a8c3ded4c36aee1fc">+[XHXNavigator currentViewController]</a></div><div class="ttdeci">UIViewController * currentViewController()</div><div class="ttdef"><b>Definition:</b> <a href="_x_h_x_navigator_8m_source.html#l00001">XHXNavigator.m:34</a></div></div>
<div class="ttc" id="ainterface_x_h_x_navigator_html_a1ab38ab3ebac8021bf5ebad00d76d203"><div class="ttname"><a href="interface_x_h_x_navigator.html#a1ab38ab3ebac8021bf5ebad00d76d203">+[XHXNavigator rootViewController]</a></div><div class="ttdeci">UIViewController * rootViewController()</div><div class="ttdef"><b>Definition:</b> <a href="_x_h_x_navigator_8m_source.html#l00001">XHXNavigator.m:14</a></div></div>
<div class="ttc" id="ainterface_x_h_x_navigator_html_ac4ee4d0dd9d4258a7388d48bd416c528"><div class="ttname"><a href="interface_x_h_x_navigator.html#ac4ee4d0dd9d4258a7388d48bd416c528">+[XHXNavigator rootWindow]</a></div><div class="ttdeci">UIWindow * rootWindow()</div><div class="ttdef"><b>Definition:</b> <a href="_x_h_x_navigator_8m_source.html#l00001">XHXNavigator.m:19</a></div></div>
<div class="ttc" id="ainterface_x_h_x_navigator_html_ae092b2e06c16c8dc6f01988ad1886a50"><div class="ttname"><a href="interface_x_h_x_navigator.html#ae092b2e06c16c8dc6f01988ad1886a50">+[XHXNavigator topWindow]</a></div><div class="ttdeci">UIWindow * topWindow()</div><div class="ttdef"><b>Definition:</b> <a href="_x_h_x_navigator_8m_source.html#l00001">XHXNavigator.m:24</a></div></div>
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="dir_05f730b1f29a3e373a3d04cb5cb42ea7.html">XHXKit</a></li><li class="navelem"><a class="el" href="dir_2d533305e802e0a7e844b4ecd2e2bdb2.html">Classes</a></li><li class="navelem"><a class="el" href="dir_c683ecabd5318f1fea2b09a69539a2dd.html">Navigator</a></li><li class="navelem"><a class="el" href="_x_h_x_navigator_8m.html">XHXNavigator.m</a></li>
    <li class="footer">制作者
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.18 </li>
  </ul>
</div>
</body>
</html>
